package org.eso.oca.data;

import java.sql.SQLException;

/**
 * Interface CalibColumnsListener
 * 
 * Listener that is notified of calib_tables table changes.
 *
 * @version $Revision: 1.4 $
 * @author pnunes, Mar 30, 2005
 */

public interface CalibTablesListener {
    /**
     * Invoked just before inserting a CalibTablesBean record into the database.
     *
     * @param pObject the CalibTablesBean that is about to be inserted
     */
    public void beforeInsert(MetaTable pObject) throws SQLException;


    /**
     * Invoked just after a CalibTablesBean record is inserted in the database.
     *
     * @param pObject the CalibTablesBean that was just inserted
     */
    public void afterInsert(MetaTable pObject) throws SQLException;


    /**
     * Invoked just before updating a CalibTablesBean record in the database.
     *
     * @param pObject the CalibTablesBean that is about to be updated
     */
    public void beforeUpdate(MetaTable pObject) throws SQLException;


    /**
     * Invoked just after updating a CalibTablesBean record in the database.
     *
     * @param pObject the CalibTablesBean that was just updated
     */
    public void afterUpdate(MetaTable pObject) throws SQLException;

}
