/* Generated By:JJTree: Do not edit this line. ASTAddition.java */

package org.eso.oca.parser;

import org.eso.oca.fits.TypedHeaderCard;
import org.eso.oca.fits.UndefinedFITSValue;

import java.lang.String;

import java.math.BigDecimal; 
import java.math.BigInteger; 

import org.apache.log4j.Logger;

public class ASTAddition extends SimpleNode
{
    public ASTAddition(int id)
    {
        super(id);
    }

    public ASTAddition(OcaParser p, int id)
    {
        super(p, id);
    }

    /** Accept the visitor. * 
     * @throws OcaVisitorException*/
    public Object jjtAccept(OcaParserVisitor visitor, Object data) throws OcaVisitorException
    {
        return visitor.visit(this, data);
    }

    public int precedence()
    {
        return ADDITION_PRECEDENCE;
    }

    static Logger logger = Logger.getLogger(ASTAddition.class);

    /** Generic fallback method for the dispatcher which catches attempts 
     * to add invalid operands. Logs an error and throws an exception. 
     *
     * @throws InterpretationException in all cases. 
     */
    Object add(Object leftOperand, Object rightOperand) 
        throws InterpretationException 
    {
        String message = getNodeLocationString() 
            + "Operator '+' may not be used for \"" 
            + TypedHeaderCard.findFITSTypeString(leftOperand) + " + " 
            + TypedHeaderCard.findFITSTypeString(rightOperand) + "\"."; 

        logger.error(message);
        throw new InterpretationException(message);
    }

    /** "Adds" an undefined value to any operand type; always returns an 
     * undefined result. 
     */
    UndefinedFITSValue add(UndefinedFITSValue leftOperand, 
                           Object rightOperand) 
    {
        String message = getNodeLocationString() 
            + "Operator '+' used with undefined operand: \"" 
            + TypedHeaderCard.findFITSTypeString(leftOperand) + " + " 
            + TypedHeaderCard.findFITSTypeString(rightOperand) + "\".";

        logger.warn(message);
        return(new UndefinedFITSValue()); 
    }

    /** "Adds" any operand type to an undefined value; always returns an 
     * undefined result. 
     */
    UndefinedFITSValue add(Object leftOperand, 
                           UndefinedFITSValue rightOperand) 
    {
        String message = getNodeLocationString() 
            + "Operator '+' used with undefined operand: \"" 
            + TypedHeaderCard.findFITSTypeString(leftOperand) + " + " 
            + TypedHeaderCard.findFITSTypeString(rightOperand) + "\".";

        logger.warn(message);
        return(new UndefinedFITSValue()); 
    }

    /** Adds two BigDecimals and returns the result. */ 
    BigDecimal add(BigDecimal leftOperand, BigDecimal rightOperand)
    {
        return(leftOperand.add(rightOperand)); 
    }

    /** Adds a BigInteger to a BigDecimal and returns the result. The 
     * BigInteger is promoted to a BigDecimal first, and a warning is 
     * logged about the type mismatch. 
     */ 
    BigDecimal add(BigDecimal leftOperand, BigInteger rightOperand)
    {
        logger.warn(getNodeLocationString() + "Performing '" 
                    + TypedHeaderCard.findFITSTypeString(leftOperand) + " + "
                    + TypedHeaderCard.findFITSTypeString(rightOperand) + "'.");
        return(leftOperand.add(new BigDecimal(rightOperand))); 
    }

    /** Adds a BigDecimal to a BigInteger and returns the result. The 
     * BigInteger is promoted to a BigDecimal first, and a warning is 
     * logged about the type mismatch. 
     */ 
    BigDecimal add(BigInteger leftOperand, BigDecimal rightOperand)
    {
        logger.warn(getNodeLocationString() + "Performing '" 
                    + TypedHeaderCard.findFITSTypeString(leftOperand) + " + "
                    + TypedHeaderCard.findFITSTypeString(rightOperand) + "'.");
        return((new BigDecimal(leftOperand)).add(rightOperand)); 
    }

    /** Adds two BigIntegers and returns the result. */ 
    BigInteger add(BigInteger leftOperand, BigInteger rightOperand)
    {
        return(leftOperand.add(rightOperand)); 
    }

    /** Concatenates two strings and returns the result. */ 
    String add(String leftOperand, String rightOperand)
    {
        return(leftOperand + rightOperand); 
    }

    /** Concatenates a string with the string representation of 
     * a non-string and returns the result. 
     */ 
    String add(String leftOperand, Object rightOperand)
    {
        return(leftOperand + rightOperand.toString()); 
    }

    /** Concatenates the string representation of a non-string 
     * with a string and returns the result. 
     */ 
    String add(Object leftOperand, String rightOperand)
    {
        return(leftOperand.toString() + rightOperand); 
    }

    public void interpret(OCAState state) throws InterpretationException 
    {
        logger.debug("interpret() called."); 

        jjtGetChild(0).interpret(state);
        jjtGetChild(1).interpret(state);

        /* Perform the operation by dispatching to the add(l,r) methods 
         * defined above. Dispatching is based on the operand types. 
         */ 
        state.stack[--state.top] = 
            dispatch(this.getClass(),
                     "add", 
                     new Object[] {state.stack[state.top], 
                                   state.stack[state.top + 1]}); 
    }
}
