/* Generated By:JJTree: Do not edit this line. ASTEquals.java */

package org.eso.oca.parser;

import org.eso.oca.fits.TypedHeaderCard;
import org.eso.oca.fits.UndefinedFITSValue;

import java.lang.Boolean;
import java.lang.String;

import java.math.BigDecimal; 
import java.math.BigInteger; 

import org.apache.log4j.Logger;

public class ASTEquals extends SimpleNode
{
    public ASTEquals(int id)
    {
        super(id);
    }

    public ASTEquals(OcaParser p, int id)
    {
        super(p, id);
    }

    /** Accept the visitor. * 
     * @throws OcaVisitorException*/
    public Object jjtAccept(OcaParserVisitor visitor, Object data) throws OcaVisitorException
    {
        return visitor.visit(this, data);
    }

    public int precedence()
    {
        return COMPARISON_PRECEDENCE;
    }

    static Logger logger = Logger.getLogger(ASTEquals.class);

    /** Generic fallback method for the dispatcher which catches attempts to 
     * compare invalid operands. Logs an error and throws an exception. 
     *
     * @throws InterpretationException in all cases. 
     */
    Object equals(Object leftOperand, Object rightOperand) 
        throws InterpretationException 
    {
        String message = getNodeLocationString() 
            + "Operator '==' may not be used for \"" 
            + TypedHeaderCard.findFITSTypeString(leftOperand) + " == " 
            + TypedHeaderCard.findFITSTypeString(rightOperand) + "\"."; 

        logger.error(message);
        throw new InterpretationException(message);
    }

    /** "Compares" an undefined value with any operand type; always returns 
     * false. 
     */
    Boolean equals(UndefinedFITSValue leftOperand, Object rightOperand) 
    {
        String message = getNodeLocationString() 
            + "Operator '==' used with undefined operand: \"" 
            + TypedHeaderCard.findFITSTypeString(leftOperand) + " == " 
            + TypedHeaderCard.findFITSTypeString(rightOperand) + "\".";

        logger.debug(message);
        return(new Boolean(false)); 
    }

    /** "Compares" any operand type with an undefined value; always returns 
     * false. 
     */
    Boolean equals(Object leftOperand, UndefinedFITSValue rightOperand) 
    {
        String message = getNodeLocationString() 
            + "Operator '==' used with undefined operand: \"" 
            + TypedHeaderCard.findFITSTypeString(leftOperand) + " == " 
            + TypedHeaderCard.findFITSTypeString(rightOperand) + "\".";

        logger.debug(message);
        return(new Boolean(false)); 
    }

    /** Compares one BigDecimal to another and returns the result. */
    Boolean equals(BigDecimal leftOperand, BigDecimal rightOperand)
    {
        return(new Boolean(leftOperand.compareTo(rightOperand) == 0)); 
    }

    /** Compares a BigDecimal to a BigInteger and returns the result. The 
     * BigInteger is promoted to a BigDecimal first, and a warning is 
     * logged about the type mismatch. 
     */
    Boolean equals(BigDecimal leftOperand, BigInteger rightOperand)
    {
        logger.warn(getNodeLocationString() + "Performing '" 
                    + TypedHeaderCard.findFITSTypeString(leftOperand) + " == " 
                    + TypedHeaderCard.findFITSTypeString(rightOperand) + "'.");

        BigDecimal promotedRightOperand = new BigDecimal(rightOperand);
        return(new Boolean(leftOperand.compareTo(promotedRightOperand) == 0)); 
    }

    /** Compares a BigInteger to a BigDecimal and returns the result. The 
     * BigInteger is promoted to a BigDecimal first, and a warning is 
     * logged about the type mismatch. 
     */
    Boolean equals(BigInteger leftOperand, BigDecimal rightOperand)
    {
        logger.warn(getNodeLocationString() + "Performing '" 
                    + TypedHeaderCard.findFITSTypeString(leftOperand) + " == " 
                    + TypedHeaderCard.findFITSTypeString(rightOperand) + "'.");

        BigDecimal promotedLeftOperand = new BigDecimal(leftOperand);
        return(new Boolean(promotedLeftOperand.compareTo(rightOperand) == 0)); 
    }
    
    /** Compares one BigInteger to another and returns the result. */
    Boolean equals(BigInteger leftOperand, BigInteger rightOperand)
    {
        return(new Boolean(leftOperand.equals(rightOperand))); 
    }

    /** Compares one String to another and returns the result. */
    Boolean equals(String leftOperand, String rightOperand) 
    {
        return(new Boolean(leftOperand.equals(rightOperand))); 
    }

    /** Compares one Boolean to another and returns the result. */
    Boolean equals(Boolean leftOperand, Boolean rightOperand) 
    {
        return(new Boolean(leftOperand.equals(rightOperand))); 
    }

    public void interpret(OCAState state) throws InterpretationException 
    {
        logger.debug("interpret() called."); 
        ++state.opCounter;

        jjtGetChild(0).interpret(state);
        jjtGetChild(1).interpret(state);

        /* Perform the operation by dispatching to the equals(l,r) methods 
         * defined above. Dispatching is based on the operand types. 
         */ 

        state.stack[--state.top] = 
            dispatch(this.getClass(), 
                     "equals", 
                     new Object[] {state.stack[state.top], 
                                   state.stack[state.top + 1]}); 
    }
}
