/* Generated By:JJTree: Do not edit this line. ASTLike.java */

package org.eso.oca.parser;

import org.eso.oca.fits.TypedHeaderCard;
import org.eso.oca.fits.UndefinedFITSValue;

import java.lang.String;
import java.lang.StringBuffer;

import org.apache.log4j.Logger;

public class ASTLike extends SimpleNode
{
    public ASTLike(int id)
    {
        super(id);
    }

    public ASTLike(OcaParser p, int id)
    {
        super(p, id);
    }

    /** Accept the visitor. * 
     * @throws OcaVisitorException*/
    public Object jjtAccept(OcaParserVisitor visitor, Object data) throws OcaVisitorException
    {
        return visitor.visit(this, data);
    }

    public int precedence()
    {
        return COMPARISON_PRECEDENCE;
    }

    static Logger logger = Logger.getLogger(ASTLike.class);

    /** Escapes all characters in the given string which are significant to 
     * regular expressions and returns the result. 
     */
    private String escapeForRegex(String str)
    {
        /* These characters are significant in regular expressions. */
        String regexChars = "\\[]^-&.{}$?*+,|():=!<>"; 

        int length = str.length(); 
        char currentChar; 
        StringBuffer result = new StringBuffer(length); 

        /* Work through the characters in 'str' one by one. */ 
        for(int i = 0; i < length; ++i)
        {
            currentChar = str.charAt(i); 

            if(regexChars.indexOf(currentChar) >= 0)
            {
                /* This character is significant in regular expressions - 
                 * escape it by adding a backslash to the result string. 
                 */
                result.append('\\'); 
            }
            
            /* Add the current character to the result string. */ 
            result.append(currentChar); 
        }

        return(result.toString()); 
    }

    /** Converts the given OCA 'like' operator match pattern string to a 
     * regular expression string and returns the result. */
    private String convertToRegex(String pattern)
    {
        /* Escape all characters in 'pattern' which are significant to 
         * regular expressions. 
         */
        pattern = escapeForRegex(pattern);

        int length = pattern.length(); 
        char currentChar; 
        StringBuffer result = new StringBuffer(length); 

        /* The match should begin at the start of the string. */ 
        result.append("\\A");

        for(int i = 0; i < length; ++i)
        {
            currentChar = pattern.charAt(i); 
            
            if(currentChar == '%')
            {
                if(((i + 1) < length) && (pattern.charAt(i + 1) == '%')) 
                {
                    /* The "%%" string has been detected - this is accepted 
                     * as a literal '%' by the OCA 'like' operator. Output 
                     * one '%' character, then advance the pattern index to 
                     * skip the second '%' at the next loop iteration. 
                     */
                    result.append('%'); 
                    ++i; 
                }
                else
                {
                    /* A single '%' character has been detected. The OCA 
                     * 'like' operator accepts this as its equivalent to 
                     * the regular expression ".*", so output that. 
                     */
                    result.append(".*"); 
                }
            }
            else
            {
                /* This character is not significant to the OCA 'like' 
                 * operator - output it as it stands. 
                 */ 
                result.append(currentChar); 
            }
        }

        /* The match should extend to the end of the string. */ 
        result.append("\\z");

        return(result.toString()); 
    }

    /** Generic fallback method for the dispatcher which catches attempts 
     * to perform the 'like' operation with invalid operands. Logs an error 
     * and throws an exception. 
     * 
     * @throws InterpretationException in all cases. 
     */
    Object like(Object leftOperand, Object rightOperand) 
        throws InterpretationException 
    {
        String message = getNodeLocationString() 
            + "Operator 'like' may not be used for \"" 
            + TypedHeaderCard.findFITSTypeString(leftOperand) + " like " 
            + TypedHeaderCard.findFITSTypeString(rightOperand) + "\"."; 

        logger.error(message);
        throw new InterpretationException(message);
    }

    /** "Compares" any operand type with an undefined value; always returns 
     * false. 
     */
    Boolean like(Object leftOperand, UndefinedFITSValue rightOperand) 
    {
        String message = getNodeLocationString() 
            + "Operator 'like' used with undefined operand: \"" 
            + TypedHeaderCard.findFITSTypeString(leftOperand) + " like " 
            + TypedHeaderCard.findFITSTypeString(rightOperand) + "\".";

        logger.debug(message);
        return(new Boolean(false)); 
    }

    /** "Compares" an undefined value with any operand type; always returns 
     * false. 
     */
    Boolean like(UndefinedFITSValue leftOperand, Object rightOperand) 
    {
        String message = getNodeLocationString() 
            + "Operator 'like' used with undefined operand: \"" 
            + TypedHeaderCard.findFITSTypeString(leftOperand) + " like " 
            + TypedHeaderCard.findFITSTypeString(rightOperand) + "\".";

        logger.debug(message);
        return(new Boolean(false)); 
    }

    /** Performs the 'like' operation with two Strings. */
    Boolean like(String leftOperand, String rightOperand)
    {
        return(new Boolean(leftOperand.matches(convertToRegex(rightOperand))));
    }

    public void interpret(OCAState state) throws InterpretationException 
    {
        logger.debug("interpret() called."); 

        jjtGetChild(0).interpret(state);
        jjtGetChild(1).interpret(state);

        /* Perform the operation by dispatching to the like(l,r) methods 
         * defined above. Dispatching is based on the operand types. 
         */ 
        state.stack[--state.top] = 
            dispatch(this.getClass(), 
                     "like", 
                     new Object[] {state.stack[state.top], 
                                   state.stack[state.top + 1]}); 
    }
}
