/* Generated By:JJTree: Do not edit this line. ASTLogicalAnd.java */

package org.eso.oca.parser;

import org.apache.log4j.Logger;

public class ASTLogicalAnd extends SimpleNode
{
    public ASTLogicalAnd(int id)
    {
        super(id);
    }

    public ASTLogicalAnd(OcaParser p, int id)
    {
        super(p, id);
    }

    /** Accept the visitor. * 
     * @throws OcaVisitorException*/
    public Object jjtAccept(OcaParserVisitor visitor, Object data) throws OcaVisitorException
    {
        return visitor.visit(this, data);
    }

    public int precedence()
    {
        return LOGICAL_AND_PRECEDENCE;
    }

    static Logger logger = Logger.getLogger(ASTLogicalAnd.class);

    public void interpret(OCAState state) throws InterpretationException 
    {
        logger.debug("interpret() called."); 

        /* Interpret the left hand side of the AND. */
        jjtGetChild(0).interpret(state); 

        /* The result needs to be Boolean. */
        state.stack[state.top] = getBoolean(state.stack[state.top]); 

        /* Following the principle of short-circuit operators, the right 
         * hand side of the AND (and the AND operation itself) only need 
         * to be interpreted if the left hand side was true. 
         */
        if(((Boolean) state.stack[state.top]).booleanValue())
        {
            /* Interpret the right hand side of the AND. */ 
            jjtGetChild(1).interpret(state);

            /* The result needs to be Boolean. */
            state.stack[state.top] = getBoolean(state.stack[state.top]); 

            /* Perform the AND operation. */
            state.stack[--state.top] = 
                new Boolean(((Boolean) state.stack[state.top]).booleanValue()
                            && ((Boolean) state.stack[state.top + 1]).booleanValue()); 
        }
    }
}
