/* Generated By:JJTree: Do not edit this line. ASTProduct.java */

package org.eso.oca.parser;

import java.util.Hashtable;

import org.apache.log4j.Logger;
import org.eso.oca.fits.OCAFile;

public class ASTProduct extends SimpleNode {
	public String name;

	public ASTProduct(int id) {
		super(id);
	}

	public ASTProduct(OcaParser p, int id) {
		super(p, id);
	}

	/***************************************************************************
	 * Accept the visitor.
	 * 
	 * @throws OcaVisitorException
	 */
	public Object jjtAccept(OcaParserVisitor visitor, Object data)
			throws OcaVisitorException {
		return visitor.visit(this, data);
	}

	static Logger logger = Logger.getLogger(ASTProduct.class);

	public void interpret(OCAState state) throws InterpretationException {
		logger.debug("interpret() called.");

		/*
		 * clear the symtab. It will be filled with the keyword values of this
		 * virtual product
		 */
		state.symtab = new Hashtable();
		int i, k = jjtGetNumChildren();
		for (i = 0; i < k; i++) {
			/*
			 * interpret a ProductKeywordDefinition node. it's just a
			 * keyword-value pair that will be stored in the symtab.
			 */
			jjtGetChild(i).interpret(state);
		}
		/*
		 * create a new virtual product with the same properties as the
		 * inputFile.
		 */
		Hashtable virtualProduct = new Hashtable(state.inputFileSymtab);
		/* add the product-specific properties */
		virtualProduct.putAll(state.symtab);
		/* add the VIRTUAL flag */
		virtualProduct.put(OCAFile.VIRTUAL, "");
		String dpId = (String) state.inputFileSymtab.get(OCAFile.DP_ID);
		String proCatg = (String) state.symtab.get(OCAFile.PRO_CATG);
		if (proCatg == null) {
			logger.error(OCAFile.PRO_CATG + " is not defined for product " + name);
		}
		String proExt = (String) state.symtab.get(OCAFile.PRO_EXT);
		if (proExt == null) {
			logger.warn(OCAFile.PRO_EXT + " is not defined for product " + name);
			proExt = "0001.fits";
			state.symtab.put(OCAFile.PRO_EXT, proExt);
		}
		String pipefile = "r." + dpId + "_" + proExt;
		/* add the PIPEFILE */
		virtualProduct.put(OCAFile.PIPEFILE, pipefile);
		/* add this product to the AB virtual products */
		state.globVirtualProducts.add(virtualProduct);
	}
}