/* Generated By:JJTree: Do not edit this line. ASTTypeConst.java */

package org.eso.oca.parser;

import org.apache.log4j.Logger;
import org.eso.oca.fits.UndefinedFITSValue;

/** <p>ASTTypeConst objects are used as placeholders in an OCA parse 
 * tree. When placed in a tree by the parser, they represent objects of 
 * the type set in the value field. Calling {@link #interpret(OCAState)} 
 * on an ASTTypeConst object pushes a new object of the appropriate type 
 * onto the interpretation stack. The value carried by the pushed object 
 * is not significant and should not be relied upon.</p> 
 * 
 * <p>Instances of ASTTypeConst are normally only seen in parse trees as 
 * children of {@link ASTIs} objects.</p> 
 */ 
public class ASTTypeConst extends SimpleNode
{
    /** Indicates the object type that {@link #interpret(OCAState)} calls 
     * should place on the interpretation stack. 
     * 
     * @see #UNDEFINED 
     */ 
    public int value;

    /** <p>Corresponds to the FITS UNDEFINED type (currently represented 
     * by an UndefinedFITSValue object).</p> 
     * 
     * <p>NOTE: should the list of valid types be expanded, these 
     * constants may be superseded by the type constants defined 
     * by the {@link org.eso.oca.fits.TypedHeaderCard} class.</p> 
     *
     * @see #value 
     */ 
    public final static int UNDEFINED = 0; 

    static Logger logger = Logger.getLogger(ASTTypeConst.class);

    public ASTTypeConst(int id)
    {
        super(id);
    }

    public ASTTypeConst(OcaParser p, int id)
    {
        super(p, id);
    }

    /** Accept the visitor. */
    public Object jjtAccept(OcaParserVisitor visitor, Object data)
        throws OcaVisitorException
    {
        return visitor.visit(this, data);
    }

    public void interpret(OCAState state) throws InterpretationException
    {
        logger.debug("interpret() called.");

        switch (value)
        {
          case UNDEFINED:
            state.stack[++state.top] = new UndefinedFITSValue();
            break;

          default:
            throw new InterpretationException(
                "Type constant [" + value + "] not recognised."); 
        }
    }
}
