package org.eso.oca.parser;

import java.lang.String;
import java.lang.RuntimeException;

/** This exception is thrown by the OCA system's built-in interpreter if it 
 * cannot find a method to reflectively dispatch to. 
 *
 * @author Neil Ferguson ESO/DMD/DFS <nferguso@eso.org> 
 */
public class DispatchNoSuchMethodException extends RuntimeException 
{
    /** Creates a DispatchNoSuchMethodException with no detail message or 
     * cause. 
     */
    public DispatchNoSuchMethodException()
    {
        super();
    }

    /** Creates a DispatchNoSuchMethodException with the specified detail 
     * message.
     * 
     * @param message a detail message for this error. 
     */
    public DispatchNoSuchMethodException(String message)
    {
        super(message);
    }

    /** Creates a DispatchNoSuchMethodException with the specified detail 
     * message and cause. 
     *
     * @param message a detail message for this error. 
     * @param cause a Throwable which represents the underlying cause of 
     *              this error. 
     */
    public DispatchNoSuchMethodException(String message, Throwable cause)
    {
        super(message, cause);
    }

    /** Creates a DispatchNoSuchMethodException with the specified cause. 
     * 
     * @param cause a Throwable which represents the underlying cause of 
     *              this error. 
     */
    public DispatchNoSuchMethodException(Throwable cause)
    {
        super(cause);
    }
}
