/*
 * Created on Jun 15, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.eso.oca.parser;

import java.io.FileInputStream;
import java.util.Calendar;

import org.apache.log4j.BasicConfigurator;
import org.apache.log4j.Level;
import org.apache.log4j.Logger;
import org.eso.oca.backend.AssociationBlock;
import org.eso.oca.fits.OCAFile;
import org.eso.oca.fits.OCAFileFactory;

/**
 * @author szampier
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class TestCreateAB
{
    /**
     * When running this code, the first command line parameter (args[0]) is the
     * rule file, the second (args[1]) is the HDR file to classify.
     */
    private static Logger ocaLogger = Logger.getLogger("org.eso.oca");
    
    static Logger fileLogger = Logger.getLogger(OCAFileFactory.class);
    
    private static Logger logger = Logger.getLogger(TestCreateAB.class);
    
    final static String usage = "Usage: TestCreateAB <oca rules> <raw dir> <calib dir>";
    
    //final static String ocaRules = "test/org/eso/oca/config/giraffe.all";

    //final static String rawDir = "z:/giraffe/raw_hdr";

    //final static String calibDir = "z:/giraffe/red_fits";

    public static void main(String[] args)
    {
        String ocaRules = "";	
        String rawDir = "";	
        String calibDir = "";
        
        try
        {
            ocaRules = new String(args[0]);	
            rawDir = new String(args[1]);	
            calibDir = new String(args[2]);
        } catch (Throwable t) {
            System.out.println(usage);
            System.exit(1);
        }
        
        try
        {
            /* Configure logging. */
            BasicConfigurator.configure();
            ocaLogger.setLevel(Level.INFO);
            logger.setLevel(Level.INFO);
            //fileLogger.setLevel(Level.DEBUG);

            
            logger.info("OCA Rules: "+ocaRules);
            logger.info("Raw Dir: "+rawDir);
            logger.info("Calib Dir: "+calibDir);
            
            /* Parse the rules. */
            OcaParser parser = new OcaParser(new FileInputStream(ocaRules));
            ASTStart start = parser.Start();
            
            //start.dumpSymtab();

            /*
             * Find out which keyword values are needed from the HDR file.
             */
            String[] requestedData = start.getRequestedData();

            long startTime = Calendar.getInstance().getTimeInMillis();
            long endTime = startTime;

            OCAFileFactory rawFactory = new OCAFileFactory(rawDir);
            OCAFile[] rawFiles = rawFactory.createOCAFiles(0, requestedData, null);
            endTime = Calendar.getInstance().getTimeInMillis();
            logger.info("loading "+rawFiles.length+" raw files : "+(endTime-startTime)/1000.);
            startTime = endTime;

            OCAFileFactory calibFactory = new OCAFileFactory(calibDir);
            OCAFile[] calibFiles = calibFactory.createOCAFiles(0, requestedData, null);
            endTime = Calendar.getInstance().getTimeInMillis();
            logger.info("loading "+calibFiles.length+" calib files : "+(endTime-startTime)/1000.);
            startTime = endTime;

            //double secs = (Calendar.getInstance().getTimeInMillis() -
            // startTime)/1000.;
            //logger.info("files/sec "+(double)count/secs);
            rawFiles = start.classify(rawFiles);
            endTime = Calendar.getInstance().getTimeInMillis();
            logger.info("classify "+rawFiles.length+" raw files : "+(endTime-startTime)/1000.+" secs");
            startTime = endTime;

            AssociationBlock[] assocBlocks = new AssociationBlock[0];
            assocBlocks = start.organize(rawFiles);
            endTime = Calendar.getInstance().getTimeInMillis();
            logger.info("organize "+rawFiles.length+" raw files : "+(endTime-startTime)/1000.+" secs");
            startTime = endTime;

            assocBlocks = start.associate(assocBlocks, rawFiles, calibFiles);
            endTime = Calendar.getInstance().getTimeInMillis();
            logger.info("associate "+assocBlocks.length+" groups : "+(endTime-startTime)/1000.+" secs");
            startTime = endTime;

            for (int i=0; i<assocBlocks.length; i++)
            {
                System.out.println(assocBlocks[i]);
            }

        } catch (Throwable t)
        {
            t.printStackTrace();
        }
    }
}

