package org.eso.util.dal;

import java.util.List;
import java.util.Map;

public interface PackageAuxFilesDAO {

	public List<String> getAuxFiles(String fileId) throws DAOException;
	
	public Map<String, List<String> > getAuxFiles(Integer pkgId) throws DAOException;
	
	public Map<String, List<String> > getAuxFiles(Integer pkgId, List<String> fileIds) throws DAOException;
	
	public void insertPackageAuxFile(Integer pkgId, String fileId, String filename) throws DAOException;
	
	public void insertPackageAuxFiles(Integer pkgId, Map<String, List<String>> packageFiles) throws DAOException;
	
	public void insertPackageAuxFilesIfNotFound(Integer pkgId, Map<String, List<String>> packageFiles) throws DAOException;
	
	public void deletePackageAuxFile(Integer pkgId, String fileId, String filename) throws DAOException;
	
	public void deletePackageAuxFiles(Integer pkgId, Map<String, List<String>> packageFiles) throws DAOException;
	
	public boolean findPackageAuxFile(Integer pkgId, String fileId, String filename) throws DAOException;
	
}
