package org.eso.util.filesystem;

import java.io.File;
import java.util.Vector;

/** A FileSelectionModel based on returning all files under a specified
 * root directory
 * @author szampier
 */
public class RecursiveFileSelectionModel extends FileSelectionModel
{
    String rootDir = null;
    
    Vector fileList = new Vector();
    
    public RecursiveFileSelectionModel(String dir)
    {
        if (dir==null)
            throw new IllegalArgumentException("null dir");
        rootDir = dir;
    }
    
    public Vector getFileList()
    {
        fileList = new Vector();
        getFileList(new File(rootDir));
        return fileList;
    }
    
    private void getFileList(File dir) {
        if (dir.isDirectory()) {
            String[] children = dir.list();
            for (int i=0; i<children.length; i++) {
                getFileList(new File(dir, children[i]));
            }
        } else {
            fileList.add(dir.getAbsolutePath());
        }
    }
    
    public static void main(String args[])
    {
        RecursiveFileSelectionModel fileSelection = new RecursiveFileSelectionModel("z:/giraffe/raw_hdr");
        Vector fileList = fileSelection.getFileList();
        System.out.println(fileList);
    }
}
