package org.eso.util.requesthandler;

import java.util.HashMap;
import java.util.Map;

/**
 * Set of available archives : 
 * SAF, HST.
 * 
 * @author cmoins
 * 
 */
public enum ArchiveName {
    SAF("SAF"), HST("HST");

    // String representation of an archive name
    private String name;

    private static final Map<String, ArchiveName> INSTANCES =
            new HashMap<String, ArchiveName>();
    
    static {
        INSTANCES.put(SAF.toString(), SAF);
        INSTANCES.put(HST.toString(), HST);
    }

    ArchiveName(String name) {
        this.name = name;
    }

    /** returns the string representation of an archive enum type element */
    public String toString() {
        return name;
    }
    /** returns the archive enum type element associated to a string */
    public static ArchiveName getInstance(String name) {
        return INSTANCES.get(name.trim());
    }
}
