package org.eso.util.requesthandler;

import java.util.HashMap;
import java.util.Map;

/**
 * Possible states of a file belonging to a requested data set :
 * UNKNOWN, RETRIEVABLE, PROPRIETARY, MISSING
 * 
 * @author cmoins
 * 
 */
public enum DatasetFileStatus {

    UNKNOWN("?"), RETRIEVABLE("F"), PROPRIETARY("P"), MISSING("N");

    // String representation of a data set file status
    private String status;
    private static final Map<String, DatasetFileStatus> INSTANCES =
            new HashMap<String, DatasetFileStatus>();

    static {
        DatasetFileStatus[] fileStatusArray = DatasetFileStatus.values();
        for (int i = 0; i< fileStatusArray.length;i++){
            INSTANCES.put(fileStatusArray[i].toString(),fileStatusArray[i]);
        }
    }

    DatasetFileStatus(String status) {
        this.status = status;
    }

    /** returns the string representation of a datafile status enum type element */
    public String toString() {
        return status;
    }
    
    /** returns the status enum type element associated to a string */
    public static DatasetFileStatus getInstance(String status) {
        return INSTANCES.get(status.trim());
    }
}
