package org.eso.util.requesthandler;

import java.util.List;

/**
 * Interface of DAO classes dealing with dataset requests
 * 
 * @author cmoins
 * 
 */
public interface DatasetRequestDAO {

    /**
     * saves a user request and the associated data set files into the
     * repository
     * 
     * @param request
     *            request to be saved
     * @throws DAOException when fails
     */
    public void save(DatasetRequest request) throws DAOException;

    /**
     * gives the list of data set requests associated to a request number and
     * their content
     * 
     * @param requestNumber
     *            identifier of the request to be retrieved
     * @return a list of data set requests
     * @throws DAOException when fails
     */
    public List<DatasetRequest> findByRequestNumber(String requestNumber)
            throws DAOException;

}
