package org.eso.util.requesthandler;

import java.util.HashMap;
import java.util.Map;

/**
 * Possibles priority levels for a dataset request : HIGH, INTERMEDIATE, LOW.
 * 
 * @author cmoins
 * 
 */
public enum DatasetRequestPriority {

    HIGH("H"), INTERMEDIATE("I"), LOW("L");

    // String representation of a priority level
    private String priority;

    private static final Map<String, DatasetRequestPriority> INSTANCES =
            new HashMap<String, DatasetRequestPriority>();

    static {
        INSTANCES.put(HIGH.toString(), HIGH);
        INSTANCES.put(INTERMEDIATE.toString(), INTERMEDIATE);
        INSTANCES.put(LOW.toString(), LOW);
    }

    DatasetRequestPriority(String priority) {
        this.priority = priority;
    }

    /** returns the string representation of an archive enum type element */
    public String toString() {
        return priority;
    }

    /** returns the priority enum type element associated to a string */
    public static DatasetRequestPriority getInstance(String priority) {
        return INSTANCES.get(priority.trim());
    }
}
