package org.eso.util.requesthandler;

import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.dao.DataAccessException;
import org.springframework.orm.hibernate3.HibernateTemplate;

/**
 * Implementation of a ngas file dao for sybase
 * 
 * @author cmoins
 * 
 */
public class NgasFileDAOSyb implements NgasFileDAO {

    // hibernate helper
    private HibernateTemplate hibernateTemplate;



    @SuppressWarnings("unchecked")
    public List<NgasFile> findByFileIdAndDomainAndStatus(String fileId,
            NgasHostDomain domain, NgasFileStatus status) throws DAOException {
        
        if ((fileId == null) || (domain == null) || (status == null)) {
            String message = "  Some arguments are missing";
            throw new IllegalArgumentException(message);
        }
        // Execution of the query to retrieve ngas files according to their file
        // id, domain and state
        final String QUERY_NAME = "findByFileIdAndDomainAndStatus";
        try {
            String paramName[] = { "fileId", "status", "domain" };
            Object value[] = { fileId, status, domain };
            List<NgasFile> ngasFileList =
                    (List<NgasFile>) hibernateTemplate.findByNamedQueryAndNamedParam(QUERY_NAME,
                            paramName,
                            value);
            return (ngasFileList);
        } catch (DataAccessException dAEx) {
            throw new DAOException(dAEx.getMessage());
        }
    }

    public void setHibernateTemplate(HibernateTemplate hibernateTemplate) {
        this.hibernateTemplate = hibernateTemplate;
    }

}
