package org.eso.util.requesthandler;

import java.util.Collections;
import java.util.HashMap;
import java.util.Map;

/**
 * Available status of a ngas file : VALID
 * 
 * @author cmoins
 * 
 */
public enum NgasFileStatus {
    VALID("00000000");

    // String representation of a NGAS file status
    private String status;

    private static final Map<String, NgasFileStatus> INSTANCES =
            Collections.synchronizedMap(new HashMap<String, NgasFileStatus>());

    static {
        NgasFileStatus[] fileStatusArray = NgasFileStatus.values();
        for (int i = 0; i < fileStatusArray.length; i++) {
            INSTANCES.put(fileStatusArray[i].toString(), fileStatusArray[i]);
        }
    }

    NgasFileStatus(String status) {
        this.status = status;
    }

    /** returns the string representation of a ngas file status enum type element */
    public String toString() {
        return status;
    }

    /** returns the status enum type element associated to a string */
    public static NgasFileStatus getInstance(String status) {
        return INSTANCES.get(status.trim());
    }
}
