/**
 * @author N. Kornweibel
 * @version 1.0
 */

package org.eso.gasgano.gui;

import java.util.Enumeration;
import java.util.Vector;

import javax.swing.AbstractListModel;

import org.eso.gasgano.datamodel.filesystem.DFSFile;

public class FileListModel extends AbstractListModel {

    private Vector files = null;
    private String emptyTitle = "No files under this catagory";
    private String label = "Files";

    public FileListModel(Enumeration f) {
        files = new Vector();
        while (f != null && f.hasMoreElements()) {
            DFSFile dfsFile = (DFSFile) f.nextElement();
            files.addElement(dfsFile);
        }
    }

    public FileListModel(Vector f, String lbl, String et) {
        files = f;
        if (et != null) {
            emptyTitle = et;
        }
        if (lbl != null) {
            label = lbl;
        }
    }

    public String getLabel() {
        return label;
    }

    /**
     * @return the number of elements in the Model - if the model is empty
     * 1 will be returned as this is the empty message.
     */
    public int getSize() {
        int rc;
        if (files == null || files.size() == 0) {
            rc = 1;
        } else {
            rc = files.size();
        }
        return rc;
    }

    /**
     * @return true of the only entry in the model is the empty message.
     */
    public boolean isEmpty() {
        boolean rc = true;
        if (files == null || files.size() == 0) {
            rc = true;
        } else {
            rc = false;
        }
        return rc;
    }

    public void emptyList() {
        int len = 0;
        if (!isEmpty()) {
            len = files.size();
            files = null;
        }
        fireIntervalRemoved(this, 0, len);
    }

    public String getEmptyMessage() {
        return emptyTitle;
    }

    public Object getElementAt(int i) {
        Object rc;
        if (files == null || files.size() == 0) {
            rc = emptyTitle;
        } else {
            rc = files.elementAt(i);
        }
        return rc;
    }
} // end of class FileListModel.
