/**
 * @author N. Kornweibel
 * @version 1.0
 */

package org.eso.gasgano.keyword;


public class ExpressionTest {

    public static void main(String[] args) {
        if (args.length < 1 || args[0].equals("-v")) {
            System.out.println("Keyword Expression Test.");
            System.out.print("usage: [-v]|[equalTest]|[lessThanTest]");
            System.out.println("|[andTest]|[orTest]|[likeTest]");
            System.out.println("|[notlikeTest]");
            System.exit(1);
        } else if (args[0].equals("equalTest")) {
            ExpressionTest e = new ExpressionTest();
            e.equalTest();
        } else if (args[0].equals("lessThanTest")) {
            ExpressionTest e = new ExpressionTest();
            e.lessThanTest();
        } else if (args[0].equals("likeTest")) {
            ExpressionTest e = new ExpressionTest();
            e.likeTest();
        } else if (args[0].equals("notlikeTest")) {
            ExpressionTest e = new ExpressionTest();
            e.notlikeTest();
        } else if (args[0].equals("andTest")) {
            ExpressionTest e = new ExpressionTest();
            e.andTest();
        } else if (args[0].equals("orTest")) {
            ExpressionTest e = new ExpressionTest();
            e.orTest();
        }
    }

    public void equalTest() {
        Keyword origfile = new Keyword("ORIGFILE", "flat_01");
        Keyword floatKeyword = new Keyword("ANUMBER", "23.41");
        String fred = new String("fred");
        String flat_01 = new String("flat_01");
        String floatString = new String("23.41");
        Float floatVal = null;
  
        try {
            floatVal = new Float("23.41");
        } catch (NumberFormatException e) {
            System.out.println("Test failed: "+e.toString());
            return;
        }

        EqKeywordExpr eq = new EqKeywordExpr(origfile, fred);
        System.out.print(eq.toString()+": ");
        // System.out.print("String comparison: ORIGFILE = 'fred': ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }

        // System.out.print("String comparison: ORIGFILE = 'flat_01': ");
        eq = new EqKeywordExpr(origfile, flat_01);
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }

        // System.out.print("String comparison: 'fred' = ORIGFILE: ");
        eq = new EqKeywordExpr(fred, origfile);
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }

        // System.out.print("String comparison: 'flat_01' = ORIGFILE: ");
        eq = new EqKeywordExpr(flat_01, origfile);
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }

        // System.out.print("Float comparison: 23.41 = ANUMBER: ");
        eq = new EqKeywordExpr(floatVal, floatKeyword);
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }

        // System.out.print("Float comparison: ANUMBER = 23.41: ");
        eq = new EqKeywordExpr(floatKeyword, floatVal);
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }
        
        // System.out.print("String comparison: '23.41' = 23.41: ");
        eq = new EqKeywordExpr(floatString, floatVal);
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }
        
        // System.out.print("String comparison: 23.41 = '23.41': ");
        eq = new EqKeywordExpr(floatVal, floatString);
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }
        
        // System.out.print("String comparison: ANUMBER = '23.41': ");
        eq = new EqKeywordExpr(floatKeyword, floatString);
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }
        
        // System.out.print("String comparison: '23.14' = ANUMBER: ");
        eq = new EqKeywordExpr(floatString, floatKeyword);
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }
        
        // System.out.print("String comparison: ANUMBER = 'fred': ");
        eq = new EqKeywordExpr(floatKeyword, fred);
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }

        // System.out.print("String comparison: 'fred' = ANUMBER: ");
        eq = new EqKeywordExpr(fred, floatKeyword);
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }

        // System.out.print("Float comparison: 23.41 = ORIGFILE: ");
        eq = new EqKeywordExpr(floatVal, origfile);
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }

        // System.out.print("String comparison: ANUMBER = ORIGFILE: ");
        eq = new EqKeywordExpr(floatKeyword, origfile);
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }

        // System.out.print("String comparison: ORIGFILE = ANUMBER: ");
        eq = new EqKeywordExpr(origfile, floatKeyword);
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }
    }

    public void notlikeTest() {
        Keyword origfile = new Keyword("ORIGFILE", "flat_01");
        Keyword floatKeyword = new Keyword("ANUMBER", "23.41");
        String flat_01 = new String("flat_01");
        String floatString = new String("23.40");
        Float floatVal = null;
 
        try {
            floatVal = new Float("23.40");
        } catch (NumberFormatException e) {
            System.out.println("Test failed: "+e.toString());
            return;
        }
 
        NotLikeKeywordExpr eq = new NotLikeKeywordExpr(flat_01,
            new String("*flat"));
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }
 
        eq = new NotLikeKeywordExpr(flat_01, new String("flat*"));
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }
 
        eq = new NotLikeKeywordExpr(flat_01, new String("*flat*"));
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }

        eq = new NotLikeKeywordExpr(origfile, new String("*"));
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }

        eq = new NotLikeKeywordExpr(origfile, new String(""));
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }

        eq = new NotLikeKeywordExpr(floatVal, new String("*"));
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }

        eq = new NotLikeKeywordExpr(floatKeyword, new String("*flat*"));
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }

        eq = new NotLikeKeywordExpr(floatKeyword, new String("*23*4*"));
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }
    }

    public void likeTest() {
        Keyword origfile = new Keyword("ORIGFILE", "flat_01");
        Keyword floatKeyword = new Keyword("ANUMBER", "23.41");
        String flat_01 = new String("flat_01");
        String floatString = new String("23.40");
        Float floatVal = null;
 
        try {
            floatVal = new Float("23.40");
        } catch (NumberFormatException e) {
            System.out.println("Test failed: "+e.toString());
            return;
        }
 
        LikeKeywordExpr eq = new LikeKeywordExpr(flat_01,
            new String("*flat"));
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }
 
        eq = new LikeKeywordExpr(flat_01, new String("flat*"));
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }
 
        eq = new LikeKeywordExpr(flat_01, new String("*flat*"));
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }

        eq = new LikeKeywordExpr(origfile, new String("*"));
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }

        eq = new LikeKeywordExpr(origfile, new String(""));
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }

        eq = new LikeKeywordExpr(floatVal, new String("*"));
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }

        eq = new LikeKeywordExpr(floatKeyword, new String("*flat*"));
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }

        eq = new LikeKeywordExpr(floatKeyword, new String("*23*4*"));
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }
    }

    public void lessThanTest() {
        Keyword origfile = new Keyword("ORIGFILE", "flat_01");
        Keyword floatKeyword = new Keyword("ANUMBER", "23.41");
        String fred = new String("fred");
        String flat_01 = new String("flat_01");
        String floatString = new String("23.40");
        Float floatVal = null;
  
        try {
            floatVal = new Float("23.40");
        } catch (NumberFormatException e) {
            System.out.println("Test failed: "+e.toString());
            return;
        }

        // System.out.print("String comparison: ORIGFILE < 'fred': ");
        LTKeywordExpr eq = new LTKeywordExpr(origfile, fred);
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }

        // System.out.print("String comparison: ORIGFILE < 'flat_01': ");
        eq = new LTKeywordExpr(origfile, flat_01);
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }

        // System.out.print("String comparison: 'fred' < ORIGFILE: ");
        eq = new LTKeywordExpr(fred, origfile);
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }

        // System.out.print("String comparison: 'flat_01' < ORIGFILE: ");
        eq = new LTKeywordExpr(flat_01, origfile);
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }

        // System.out.print("Float comparison: 23.40 < ANUMBER: ");
        eq = new LTKeywordExpr(floatVal, floatKeyword);
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }

        // System.out.print("Float comparison: ANUMBER < 23.40: ");
        eq = new LTKeywordExpr(floatKeyword, floatVal);
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }
        
        // System.out.print("String comparison: '23.40' < 23.40: ");
        eq = new LTKeywordExpr(floatString, floatVal);
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }
        
        // System.out.print("String comparison: 23.40 < '23.40': ");
        eq = new LTKeywordExpr(floatVal, floatString);
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }
        
        // System.out.print("String comparison: ANUMBER < '23.40': ");
        eq = new LTKeywordExpr(floatKeyword, floatString);
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }
        
        // System.out.print("String comparison: '23.40' < ANUMBER: ");
        eq = new LTKeywordExpr(floatString, floatKeyword);
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }
        
        // System.out.print("String comparison: ANUMBER < 'fred': ");
        eq = new LTKeywordExpr(floatKeyword, fred);
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }

        // System.out.print("String comparison: 'fred' < ANUMBER: ");
        eq = new LTKeywordExpr(fred, floatKeyword);
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }

        // System.out.print("Float comparison: 23.40 < ORIGFILE: ");
        eq = new LTKeywordExpr(floatVal, origfile);
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }

        // System.out.print("String comparison: ANUMBER < ORIGFILE: ");
        eq = new LTKeywordExpr(floatKeyword, origfile);
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }

        // System.out.print("String comparison: ORIGFILE < ANUMBER: ");
        eq = new LTKeywordExpr(origfile, floatKeyword);
        System.out.print(eq.toString()+": ");
        try {
            System.out.println(eq.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }
    }

    public void andTest() {
        Keyword origfile = new Keyword("ORIGFILE", "flat_01");
        KeywordExpression kwEx = null;
        String flat_01 = new String("flat_01");
        Keyword floatKeyword = new Keyword("ANUMBER", "23.41");
        Float floatVal = null;
        try {
            floatVal = new Float("23.40");
        } catch (NumberFormatException e) {
            System.out.println("Test failed: "+e.toString());
            return;
        }
 
        // System.out.print("ORIGFILE = flat_01 AND 23.40 < ANUMBER: ");
       AndKeywordExpr expr = new AndKeywordExpr();
        EqKeywordExpr exp1 = new EqKeywordExpr(origfile, flat_01);
        expr.add(exp1);
        LTKeywordExpr exp2 = new LTKeywordExpr(floatVal, floatKeyword);
        expr.add(exp2);
        kwEx = new KeywordExpression(expr);
        System.out.print(kwEx.toString()+": ");
        try {
            System.out.println(expr.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }
 
        // System.out.print("ORIGFILE = flat_01 AND ANUMBER < 23.40: ");
       expr = new AndKeywordExpr();
        exp1 = new EqKeywordExpr(origfile, flat_01);
        expr.add(exp1);
        exp2 = new LTKeywordExpr(floatKeyword, floatVal);
        expr.add(exp2);
        kwEx = new KeywordExpression(expr);
        System.out.print(kwEx.toString()+": ");
        try {
            System.out.println(expr.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }
 
    }


    public void orTest() {
        Keyword origfile = new Keyword("ORIGFILE", "flat_01");
        KeywordExpression kwEx = null;
        String flat_01 = new String("flat_01");
        Keyword floatKeyword = new Keyword("ANUMBER", "23.41");
        Float floatVal = null;
        try {
            floatVal = new Float("23.40");
        } catch (NumberFormatException e) {
            System.out.println("Test failed: "+e.toString());
            return;
        }

        // System.out.print("ORIGFILE = flat_01 AND 23.40 < ANUMBER: ");
        OrKeywordExpr expr = new OrKeywordExpr();
        EqKeywordExpr exp1 = new EqKeywordExpr(origfile, flat_01);
        expr.add(exp1);
        LTKeywordExpr exp2 = new LTKeywordExpr(floatVal, floatKeyword);
        expr.add(exp2);
        kwEx = new KeywordExpression(expr);
        System.out.print(kwEx.toString()+": ");
        try {
            System.out.println(expr.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }

        // System.out.print("ORIGFILE = flat_01 AND ANUMBER < 23.40: ");
        expr = new OrKeywordExpr();
        exp1 = new EqKeywordExpr(origfile, flat_01);
        expr.add(exp1);
        exp2 = new LTKeywordExpr(floatKeyword, floatVal);
        expr.add(exp2);
        kwEx = new KeywordExpression(expr);
        System.out.print(kwEx.toString()+": ");
        try {
            System.out.println(expr.evaluate(null));
        } catch (ExpressionEvaluationException e) {
            System.out.println(e.toString());
        }

    }
}
