package org.eso.gasgano.viewers;

/**
 * @author nkornwei
 *
 * Implementation of ExternalViewer for
 * displaying files in SkyCat.
 */

import java.io.IOException;
import java.util.Vector;

public class SkyCatExternalViewer implements ExternalViewer {

    private String skyCatCommand;
    
    /**
     * @see org.eso.gasgano.ExternalViewer#setCommand(String)
     */
    public void setCommand(String command) {
        skyCatCommand = command;
    }

    /**
     * @see org.eso.gasgano.ExternalViewer#displayFile(String)
     * Note that this external viewer can only diplay a single file.
     */
    public void displayFiles(Vector filePaths) 
        throws ExternalViewerException {
        if (filePaths == null || filePaths.size() < 1) {
            throw new ExternalViewerException("Invalid or empty file paths argument.");
        }
        try {
            SkyCatConnection c = new SkyCatConnection();
            //c.setAddressFromRTDFile("//K:/" + SkyCatConnection.RtdPortFile);
            c.setAddressFromRTDFile();
            if (!c.isSkyCatRunning()) {
                c.startSkyCat(skyCatCommand);
            }
            c.setAddressFromRTDFile();
            c.sendFile(filePaths.elementAt(0).toString());
        } catch (IOException e) {
            throw new ExternalViewerException("Error sending file to SkyCat: "+e.getMessage());
        }
    }

}
